############################################################################
##
## Copyright (c) 2000-2001 BalaBit IT Ltd, Budapest, Hungary
## All rights reserved.
##
## $Id: ProxyConfig.py,v 1.7 2002/10/22 11:01:50 sasa Exp $
##
############################################################################

import UIUtils
from Config import Config
from snack import *
from ZUI.Lang import *

class ProxyConfig(Config):
    def __init__(self, owner, name):
        self.owner = owner
        self.name = name
        self.mods = {
            "PlugProxy": "Plug",
            "HttpProxy": "Http",
            "FtpProxy": "Ftp",
            "FtpProxyAllow": "Ftp",
            "FtpProxyMinimal": "Ftp",
            "PsslProxy": "Pssl",
            "AnyPyProxy": "AnyPy",
            "ImapProxy": "Imap",
            "NntpProxy": "Nntp",
            "Pop3Proxy": "Pop3",
            "LpProxy": "Lp",
            "TelnetProxy": "Telnet"
            }
        self.proxy_parms = {}
                
    def importHook(self, output, gi):
        try:
            mod = self.mods[self.name]
            self.generateImports("from Zorp.%s import *" % mod, output, gi)
                                
        except KeyError:
            pass
                
    def generateConfig(self, output, gi):
        output.write(self.name)
        
    def addForm(self):
        screen = UIUtils.screen
        
        grid = Grid(2, 1)
        self.label = Label(self.name + (40 - len(self.name))*' ')
        self.bb = ButtonBar(screen, [mylang.get("Change")], compact=1)

        grid.setField(self.label, 0, 0)
        grid.setField(self.bb, 1, 0, anchorRight=1)
        return grid
        
    def endForm(self):
        del self.label
        del self.bb

    def editCustom(self):
        x = UIUtils.EntryForm(title=mylang.get("Proxy class name"), text="PlugProxy").run()
        if x:
            self.name = x
            self.proxy_parms = {}

    def runForm(self, res):
        x = self.bb.buttonPressed(res)
        if x:
            # change pressed
            screen = UIUtils.screen
            form = GridForm(screen, mylang.get('Select proxy to use'), 2, 1)
            
            leftgrid = Grid(1, 2)
            
            proxy_l = Label(mylang.get('Proxy module'))
            proxy = Listbox(width=30, height=5, scroll=1, border=1, returnExit=1)
            
            proxy.append(mylang.get("Custom..."), None)
            for p in self.mods.keys():
                proxy.append(p, p)
                
            try:
                proxy.setCurrent(self.name)
            except KeyError:
                pass
            
            leftgrid.setField(proxy_l, 0, 0, anchorLeft=1)
            leftgrid.setField(proxy, 0, 1)
            
            main_bb = ButtonBar(screen, [(mylang.get("  Ok  "), "ok"), (mylang.get("Cancel"), "cancel")], horizontal=0)
            
            form.add(leftgrid, 0, 0)
            form.add(main_bb, 1, 0)
            
            res = form.runOnce()
            x = main_bb.buttonPressed(res)
            if x == "ok" or x == None:
                try:
                    p = proxy.current()
                    if p:
                        self.name = p
                        try:
                            f = getattr(self, 'edit' + p)
                            f()
                        except AttributeError:
                            pass
                    else:
                        self.editCustom()
                    self.label.setText(self.name)
                except KeyError:
                    pass
                pass
            return 1
