############################################################################
##
## Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
##
## All rights reserved.
##
## $Id: UIUtils.py,v 1.4 2002/10/22 11:01:50 sasa Exp $
##
## Author: Balazs Scheidler <bazsi@balabit.hu>
##
############################################################################

from snack import *
from Params import *
import ZorpConfig
from ZUI.Lang import *

screen = None
initialized = 0

class YesNoForm:
    def __init__(self, title):
        self.initForm(title)

    def initForm(self, title):
        self.form = GridForm(screen, mylang.get("Choose an answer"), 1, 2)
        self.form.add(Label(title), 0, 0, padding=(0, 1, 0, 1))
        self.bb = ButtonBar(screen, [mylang.get("Yes"), mylang.get("No")])
        self.form.add(self.bb, 0, 1)

    def run(self):
        x = self.form.run()
        screen.popWindow()
        return self.bb.buttonPressed(x)

class MessageForm:
    def __init__(self, title, text):
        self.initForm(title, text)

    def initForm(self, title, text):
        self.form = GridForm(screen, title, 1, 2)
        self.form.add(Label(text), 0, 0, padding=(0, 1, 0, 1))
        self.bb = ButtonBar(screen, [mylang.get("Ok")])
        self.form.add(self.bb, 0, 1)

    def run(self):
        x = self.form.run()
        screen.popWindow()
        return self.bb.buttonPressed(x)


class EntryForm:
    def __init__(self, title, width = 30, text = ""):
        self.initForm(title, width, text)

    def initForm(self, title, width, text):
        self.form = GridForm(screen, title, 2, 1)
        self.bb = ButtonBar(screen, [(mylang.get("  Ok  "), "ok"), (mylang.get("Cancel"), "cancel")], compact=1, horizontal=0)
        self.entry = Entry(width, text, returnExit = 1)
        self.form.add(self.entry, 0, 0)
        self.form.add(self.bb, 1, 0)

    def run(self):
        x = self.form.run()
        screen.popWindow()
        x = self.bb.buttonPressed(x)
        if x == None or x == "ok":
            x = self.entry.value()
            return x
        else:
            return None
    
class HelpForm:
    def __init__(self, title = "Help", text = "", width=50):
        self.initForm(title, width, text)
	
    def initForm(self, title, width, text):
        self.form = GridForm(screen, title, 2, 1)
        self.bb = ButtonBar(screen, [(mylang.get("  Ok  "), "ok")], horizontal=0)
        self.tb = TextboxReflowed(width, text, maxHeight=15)
        self.form.add(self.tb, 0, 0)
        self.form.add(self.bb, 1, 0)

    def run(self):
        x = self.form.runOnce()   
    
def Initialize(txt):
	global screen, initialized
	
        screen = SnackScreen()
	screen.drawRootText(0, 0, txt)
	initialized = 1

def Deinitialize():
	global screen, initialized
	
	if initialized:
            screen.finish()
            initialized = 0
