############################################################################
##
## Copyright (c) 2000-2001 BalaBit IT Ltd, Budapest, Hungary
## All rights reserved.
##
## $Id: ZoneConfig.py,v 1.7 2002/10/22 11:01:50 sasa Exp $
##
############################################################################

import UIUtils
from Config import Config
from snack import *
from string import join
from ZUI.Lang import *

class ZoneConfig(Config):
    def __init__(self, owner, name):
        self.owner = owner
        self.name = name
        self.addr = '192.168.1.0/24'
        self.addr_domain = 'inet'
        self.interface = None
        self.inbound_services = {}
        self.outbound_services = {}
        self.parent = ''
        self.umbrella = 0

    def globalHook(self, output, gi):
        info = {
            "name": self.name,
            "addr": self.addr,
            "inb": '[' + join(map(lambda x: '"' + x + '"', self.inbound_services.keys()), ',') + ']',
            "outb": '[' + join(map(lambda x: '"' + x + '"', self.outbound_services.keys()), ',') + ']',
            "class": 'InetZone',
            "parent": self.parent
            }
        output.write('%(class)s("%(name)s", "%(addr)s",\n' % info)
        if self.parent:
            output.write('\tadmin_parent="%(parent)s",\n' % info)
        if self.umbrella:
            output.write('\tumbrella=TRUE,\n')
        output.write('\tinbound_services=%(inb)s,\n\toutbound_services=%(outb)s)\n\n' % info)

    def runForm(self):

        screen = UIUtils.screen
        form = GridForm(screen, mylang.get("Address range of zone %s") % self.name, 1, 6)
	    
	addr_l = Label(mylang.get('Address range'))
	addr = Entry(30, self.addr, returnExit=1)
	
	parent_l = Label(mylang.get('Parent zone'))
	parent = Entry(30, self.parent, returnExit=1)
	
	umbrella = Checkbox(mylang.get('Umbrella'), isOn=self.umbrella)
	bb = ButtonBar(screen, [(mylang.get("  Ok  "), "ok"), (mylang.get(" Cancel "), "cancel")])
	    
	form.add(addr_l, 0, 0, anchorLeft=1)
	form.add(addr, 0, 1, padding=(0, 0, 0, 1))
	form.add(parent_l, 0, 2, anchorLeft=1)
	form.add(parent, 0, 3, padding=(0, 0, 0, 1))
	form.add(umbrella, 0, 4, padding=(0, 0, 0, 1))
	form.add(bb, 0, 5)
	
	res = form.runOnce()
	    
	x = bb.buttonPressed(res)
	if x == 'ok' or x == None:
            self.addr = addr.value()
            self.parent = parent.value()
            self.umbrella = umbrella.value()

