############################################################################
##
## Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
## All rights reserved.
##
## $Id: ZorpConfig.py,v 1.8 2002/10/22 11:01:50 sasa Exp $
##
## Author: Balazs Scheidler <bazsi@balabit.hu>
##
############################################################################

import UIUtils
from Config import Config, GenerationInfo
from ZoneConfig import ZoneConfig
from InstanceConfig import InstanceConfig
from Params import *
from snack import *
from ZUI.Lang import *

class ZorpConfig(Config):
    def __init__(self, name):
        self.owner = None
        self.name = name
        self.interfaces = {}
        self.zones = {}
        self.instances = {}

    #def addInterface(self):
    #    x = UIUtils.EntryForm(title="Interface name", text="eth0").run()
    #    if x:
    #        if self.interfaces.has_key(x):
    #            UIUtils.MessageForm("Message", "Duplicated interface name").run()
    #        else:
    #            self.interfaces[x] = InterfaceConfig(self, x)
    #            self.ifaces_lb.append(x, self.interfaces[x])

    #def editInterface(self):
    #    try:
    #        self.ifaces_lb.current().runForm()
    #    except KeyError:
    #        pass

    #def delInterface(self):
    #    try:
    #        x = self.ifaces_lb.current()
    #        if x:
    #            del self.interfaces[x.name]
    #            self.ifaces_lb.delete(x)
    #    except:
    #        pass

    def addZone(self):      
        x = UIUtils.EntryForm(title=mylang.get("Zone name"), text="intranet").run()
        if x:
            if not self.zones.has_key(x):
                self.zones[x] = ZoneConfig(self, x)
                self.zones_lb.append(x, self.zones[x])
                self.zones_lb.setCurrent(self.zones[x])
                self.editZone()
            else:
                UIUtils.MessageForm(title=mylang.get("Message"), text=mylang.get("This zone (%s) already exists.") % x).run()

    def editZone(self):
        try:
            x = self.zones_lb.current().runForm()
        except KeyError:
            pass

    def delZone(self):
        try:
            x = self.zones_lb.current()
            if x:
                try:
                    del self.zones[x.name]
                except KeyError: 
                    pass
                self.zones_lb.delete(x)
        except KeyError:
            pass


    def addInstance(self):  
        x = UIUtils.EntryForm(title=mylang.get("Instance name"), text="intra").run()
        if x:
            if self.instances.has_key(x):
                UIUtils.MessageForm(title=mylang.get("Message"), text=mylang.get("This instance (%s) already exists.") % x).run()
            else:
                self.instances[x] = InstanceConfig(self, x)
                self.instances_lb.append(x, self.instances[x])

    def editInstance(self):
        try:
            self.instances_lb.current().runForm()
        except KeyError:
	    pass

    def delInstance(self):
        try:
            x = self.instances_lb.current() 
            if x:
                del self.instances[x.name]
                self.instances_lb.delete(x)
	except KeyError:
	    pass
            
    def generateInstanceConfig(self, f, policyfile):
        f.write('# Generated automatically by zui\n')
        for x in self.instances.keys():
            f.write('%s --log-tags --verbose 3 -p %s\n' % (x, policyfile))
                
    def genConfig(self):

        quit = 0
        cancel = 0
        while not quit:
            x = UIUtils.EntryForm(title=mylang.get("Policy filename"), text="/etc/zorp/policy.py").run()
            if x:
                try:
                    f = open(x, "w")
                    self.generateConfig(f, GenerationInfo())
                    f.close()
                    quit = 1
                except IOError:
                    UIUtils.MessageForm(title=mylang.get("Error"), text=mylang.get("Error writing policy file to %s") % x).run()

            else:
                quit = 1
                cancel = 1

        if not cancel:
            quit = 0
            while not quit:
                x2 = UIUtils.EntryForm(title=mylang.get("Instances.conf filename"), text="/etc/zorp/instances.conf").run()
                if x2:
                    try:
                        f = open(x2, "w")
                        self.generateInstanceConfig(f, x)
                        f.close()
                        quit = 1
                    except IOError:
                        UIUtils.MessageForm(title=mylang.get("Error"), text=mylang.get("Error writing instances file to %s") % x2).run()
                else:
                    quit = 1
                
    def runForm(self):
        screen = UIUtils.screen
        form = GridForm(screen, mylang.get("Edit firewall %s") % self.name, 2, 1)

        main_grid = Grid(1, 2)
        
        #ifaces_grid = Grid(2, 2)
        #ifaces_l = Label(mylang.get("Interfaces"))
        #ifaces_bb = ButtonBar(screen,
        #                      [(mylang.get(" Add  "), "add"), (mylang.get(" Edit "), "edit"), (mylang.get("Delete"), "delete")],
        #                      compact=1, horizontal=0)
        #self.ifaces_lb = ifaces = Listbox(5, width=20, scroll=1, border=1)
        #
        #for iface in self.interfaces.keys():
        #    ifaces.append(iface, self.interfaces[iface])
            
        #ifaces_grid.setField(ifaces_l, 0, 0)
        #ifaces_grid.setField(Label(""), 1, 0)
        #ifaces_grid.setField(ifaces, 0, 1)
        #ifaces_grid.setField(ifaces_bb, 1, 1)
        #main_grid.setField(ifaces_grid, 0, 0)

        zones_grid = Grid(2, 2)
        zones_l = Label(mylang.get("Zones"))
        zones_bb = ButtonBar(screen,
                             [(mylang.get(" Add  "), "add"), (mylang.get(" Edit "), "edit"), (mylang.get("Delete"), "delete")],
                             compact=1, horizontal=0)
        self.zones_lb = zones = Listbox(5, width=20, scroll=1, border=1)
        
        for zone in self.zones.keys():
            zones.append(zone, self.zones[zone])

        zones_grid.setField(zones_l, 0, 0)
        zones_grid.setField(Label(""), 1, 0)
        zones_grid.setField(zones, 0, 1)
        zones_grid.setField(zones_bb, 1, 1)
        main_grid.setField(zones_grid, 0, 0)

        instances_grid = Grid(2, 2)
        instances_l = Label(mylang.get("Instances"))
        self.instances_lb = instances = Listbox(5, width=20, scroll=1, border=1)
        
        for instance in self.instances.keys():
            instances.append(instance, self.instances[instance])

        instances_bb = ButtonBar(screen,
                                 [(mylang.get(" Add  "), "add"), (mylang.get(" Edit "), "edit"), (mylang.get("Delete"), "delete")],
                                 compact=1, horizontal=0)
        instances_grid.setField(instances_l, 0, 0)
        instances_grid.setField(Label(""), 1, 0)
        instances_grid.setField(instances, 0, 1)
        instances_grid.setField(instances_bb, 1, 1)
        main_grid.setField(instances_grid, 0, 1)
        
        form.add(main_grid, 0, 0)
        
        main_bb = ButtonBar(screen, [(mylang.get("Generate"), "generate"), (mylang.get(" Close  "), "close")], horizontal=0)
        form.add(main_bb, 1, 0, (0, 1, 0, 0))

        quit = 0
        while not quit:

            x = form.run()

            #ifaces_action = ifaces_bb.buttonPressed(x)
            zones_action = zones_bb.buttonPressed(x)
            instances_action = instances_bb.buttonPressed(x)
            main_action = main_bb.buttonPressed(x)
            
            if main_action:
                if main_action == "close":
                    quit = 1
                elif main_action == "generate":
                    self.genConfig()
            #elif ifaces_action:
            #    if ifaces_action == "add":
            #        # add interface
            #        self.addInterface()
            #    elif ifaces_action == "edit":
            #        # edit interface
            #        self.editInterface()
            #    elif ifaces_action == "delete":
            #        # delete interface
            #        self.delInterface()
            elif zones_action:
                if zones_action == "add":
                    # add zone
                    self.addZone()
                elif zones_action == "edit":
                    # edit zone
                    self.editZone()
                elif zones_action == "delete":
                    # delete zone
                    self.delZone()
            elif instances_action:
                if instances_action == "add":
                    # add zone
                    self.addInstance()
                elif instances_action == "edit":
                    # edit zone
                    self.editInstance()
                elif instances_action == "delete":
                    # delete zone
                    self.delInstance()
        screen.popWindow()
            
        #del self.ifaces_lb
        del self.zones_lb
        del self.instances_lb

                
    def importHook(self, output, gi):

        output.write(
'''
# Zorp policy, automatically generated by zui %s

# import section
from Zorp.Core import *
''' % (version))

        for x in self.interfaces.keys():
            self.interfaces[x].importHook(output, gi)
                        
        for x in self.zones.keys():
            self.zones[x].importHook(output, gi)
                        
        for x in self.instances.keys():
            self.instances[x].importHook(output, gi)
                
        output.write('# end of import section\n\n')
                
    def globalHook(self, output, gi):
        
        output.write('# start of global section\n')
        output.write('Zorp.firewall_name = \'%s\'\n\n' % self.name)
        
        
        for x in self.interfaces.keys():
            self.interfaces[x].globalHook(output, gi)
                        
        for x in self.zones.keys():
            self.zones[x].globalHook(output, gi)
                        
        for x in self.instances.keys():
            self.instances[x].globalHook(output, gi)

        output.write('# end of global section\n\n')     

    def generateConfig(self, output, gi):
        self.importHook(output, gi)
        self.globalHook(output, gi)

        output.write('# start of instance section\n')
        for x in self.instances.keys():
            self.instances[x].generateConfig(output, gi)
        output.write('# end of instance section\n')

