# List of predefined services known by zui
# 
# This file is made up of lines, where each line denotes a record. The first
# character of each line determines the type of that given record. The rest
# is a free-form parameter, whose interpretation is determined by the record
# type. If a single line parameter is not enough, a single '.' character
# denotes multi-line data, which is ended by a single '.'.
#
# Help text should be word-wrapped at column 48, otherwise it'll look ugly.
#
# Format:
#   I <unique identifier>
#   S <service short description>
#   D <service long description>
#   P <service port number>
#   R <redirected port number, where zorp should be listening>
#   O <Zorp router class to use>
#   X <Zorp proxy class to use>
#   L <Zorp listener address to use>
#   M <lines to insert into import section (with duplicates removed)>
#   G <lines to insert into global section>
#   = <end of service definition>
#
#--------------------------------------------------------------------------
#
# List of predefined services known by zui
# 
# This file is made up of lines, where each line denotes a record. The first
# character of each line determines the type of that given record. The rest
# is a free-form parameter, whose interpretation is determined by the record
# type. If a single line parameter is not enough, a single '.' character
# denotes multi-line data, which is ended by a single '.'.
#
# Help text should be word-wrapped at column 48, otherwise it'll look ugly.
#
# Format:
#   I <unique identifier>
#   S <service short description>
#   D <service long description>
#   P <service port number>
#   R <redirected port number, where zorp should be listening>
#   O <Zorp router class to use>
#   X <Zorp proxy class to use>
#   L <Zorp listener address to use>
#   M <lines to insert into import section (with duplicates removed)>
#   G <lines to insert into global section>
#   = <end of service definition>
#
#--------------------------------------------------------------------------
#
#
#
# Protocol: PGSQL
#-----------------------------------------
#
I Pgsql
S Pgsql: PostgreSQL database server
D .

PostgreSQL is a free database server.

PostgreSQL uses 5432/TCP port for 
remote database connection.

NOTE: This setting uses a simple plug to
transmit pgsql traffic, thus the firewall 
is unable to analyze stream contents.

.
P 5432
R 55432
M .
from Zorp.Plug import *
.
G .

class PgsqlProxy(PlugProxy):
	pass
.
X PgsqlProxy
=
#
#
# Protocol: ORACLE SQLNET
#-----------------------------------------
#
I ORA
S ORA: Oracle database server
D .

Oracle is a commercial database server.

We do not support SQL NET with random 
port-assignment. Oracle SQL/NET uses
1521/TCP port by default.

NOTE: This setting uses a simple plug to
transmit Ora SQLnet traffic, thus the firewall 
is unable to analyze stream contents.

.
P 1521
R 51521
M .
from Zorp.Plug import *
.
G .

class OraProxy(PlugProxy):
	pass
.
X OraProxy
=
#
#
# Protocol: MySQL NET
#-----------------------------------------
#
I Mysql
S Mysql: MySQL database server
D .

MySQL is a free database server.

MySQL uses 3306/TCP port for 
remote database connection.

NOTE: This setting uses a simple plug to
transmit MySQLnet traffic, thus the firewall 
is unable to analyze stream contents.

.
P 3306
R 53306
M .
from Zorp.Plug import *
.
G .

class MySQLProxy(PlugProxy):
	pass
.
X MySQLProxy
=
#
#
# Protocol: MS SQL NET
#-----------------------------------------
#
I Mssql
S Mssql: Microsoft SQL server
D .

MSSQL is a commercial database server.

MSSQL uses 1433/TCP port for 
remote database connection.

NOTE: This setting uses a simple plug to
transmit MSSQLnet traffic, thus the firewall 
is unable to analyze stream contents.

.
P 1433
R 51433
M .
from Zorp.Plug import *
.
G .

class MSSQLProxy(PlugProxy):
	pass
.
X MSSQLProxy
=
